Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| fop 1.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.fop.render.pcl
Class PCLPainter

    java.lang.Object
      org.apache.fop.render.intermediate.AbstractIFPainter
          org.apache.fop.render.pcl.PCLPainter

All Implemented Interfaces:
  IFPainter, org.apache.fop.render.pcl.PCLConstants

public class PCLPainter
extends AbstractIFPainter
implements org.apache.fop.render.pcl.PCLConstants

`IFPainter` implementation that produces PCL 5.

Field Summary
`static java.lang.Object` | `COLOR_CANVAS` Enables/Disables a color canvas for bitmap production (required for SVG, for example)
`static java.lang.Object` | `DISABLE_CLIPPING` Disable clipping
`static org.apache.xmlgraphics.util.QName` | `SRC_TRANSPARENCY` Source transparency mode

Fields inherited from class org.apache.fop.render.intermediate.AbstractIFPainter
`INSTREAM_OBJECT_URI, state`

Constructor Summary
`PCLPainter(PCLDocumentHandler parent, PCLPageDefinition pageDefinition)` Main constructor.

Method Summary
`void` | `clipRect(java.awt.Rectangle rect)` Restricts the current clipping region with the given rectangle.
`protected RenderingContext` | `createRenderingContext()` Creates a new RenderingContext instance.
`void` | `drawBorderRect(java.awt.Rectangle rect, BorderProps before, BorderProps after, BorderProps start, BorderProps end)` Draws a border rectangle. The border segments are specified through `BorderProps` instances.
`void` | `drawImage(org.w3c.dom.Document doc, java.awt.Rectangle rect)` Draws an image (represented by a DOM document) inside a given rectangle. This is the equivalent to an fo:instream-foreign-object in XSL-FO.
`void` | `drawImage(java.lang.String uri, java.awt.Rectangle rect)` Draws an image identified by a URI inside a given rectangle. This is the equivalent to an fo:external-graphic in XSL-FO.
`void` | `drawLine(java.awt.Point start, java.awt.Point end, int width, java.awt.Color color, RuleStyle style)` Draws a line. NOTE: Currently, only horizontal lines are implemented!
`void` | `drawText(int x, int y, int letterSpacing, int wordSpacing, int[] dx, java.lang.String text)` Draws text. The initial coordinates (x and y) point to the starting point at the normal baseline of the font. The parameters letterSpacing, wordSpacing and the array dx are optional and can be used to influence character positioning (for example, for kerning).
`void` | `endGroup()` Ends the current group and restores the previous coordinate system.
`void` | `endViewport()` Ends the current viewport and restores the previous coordinate system.
`void` | `fillRect(java.awt.Rectangle rect, java.awt.Paint fill)` Fills a rectangular area.
`IFContext` | `getContext()` Returns the intermediate format context object.
`protected int` | `getResolution()`
`void` | `startGroup(java.awt.geom.AffineTransform transform)` Starts a new group of graphical elements. Corresponds to SVG's g element.
`void` | `startViewport(java.awt.geom.AffineTransform transform, java.awt.Dimension size, java.awt.Rectangle clipRect)` Starts a new viewport, establishing a new coordinate system. A viewport has a size and can optionally be clipped. Corresponds to SVG's svg element.

Methods inherited from class org.apache.fop.render.intermediate.AbstractIFPainter
`createDefaultImageProcessingHints, drawImage, drawImage, drawImageUsingDocument, drawImageUsingImageHandler, drawImageUsingURI, getFopFactory, getImageInfo, getLineBoundingBox, getUserAgent, setFont, startGroup, startViewport, toPoints`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### SRC_TRANSPARENCY

    public static final org.apache.xmlgraphics.util.QName SRC_TRANSPARENCY

  Source transparency mode

### DISABLE_CLIPPING

    public static final java.lang.Object DISABLE_CLIPPING

  Disable clipping

### COLOR_CANVAS

    public static final java.lang.Object COLOR_CANVAS

  Enables/Disables a color canvas for bitmap production (required for SVG, for example)

Constructor Detail

### PCLPainter

    public PCLPainter(PCLDocumentHandler parent,
                      PCLPageDefinition pageDefinition)

  Main constructor.

Parameters:
  `parent` - the parent document handler
  `pageDefinition` - the page definition describing the page to be rendered

Method Detail

### getContext

    public IFContext getContext()

  Returns the intermediate format context object.

  Specified by:
    `getContext` in class `AbstractIFPainter`
  Returns:
    the context object

### getResolution

    protected int getResolution()

  Returns:
    the target resolution

### startViewport

    public void startViewport(java.awt.geom.AffineTransform transform,
                              java.awt.Dimension size,
                              java.awt.Rectangle clipRect)
                       throws IFException

  Starts a new viewport, establishing a new coordinate system. A viewport has a size and can optionally be clipped. Corresponds to SVG's svg element.

  Specified by:
    `startViewport` in interface `IFPainter`
  Parameters:
    `transform` - the transformation matrix establishing the new coordinate system
    `size` - the size of the viewport
    `clipRect` - the clipping rectangle (may be null)
  Throws:
    `IFException` - if an error occurs while handling this element

### endViewport

    public void endViewport()
                     throws IFException

  Ends the current viewport and restores the previous coordinate system.

  Specified by:
    `endViewport` in interface `IFPainter`
  Throws:
    `IFException` - if an error occurs while handling this element

### startGroup

    public void startGroup(java.awt.geom.AffineTransform transform)
                    throws IFException

  Starts a new group of graphical elements. Corresponds to SVG's g element.

  Specified by:
    `startGroup` in interface `IFPainter`
  Parameters:
    `transform` - the transformation matrix establishing the new coordinate system
  Throws:
    `IFException` - if an error occurs while handling this element

### endGroup

    public void endGroup()
                  throws IFException

  Ends the current group and restores the previous coordinate system.

  Specified by:
    `endGroup` in interface `IFPainter`
  Throws:
    `IFException` - if an error occurs while handling this element

### drawImage

    public void drawImage(java.lang.String uri,
                          java.awt.Rectangle rect)
                   throws IFException

  Draws an image identified by a URI inside a given rectangle. This is the equivalent to an fo:external-graphic in XSL-FO.

  Specified by:
    `drawImage` in interface `IFPainter`
  Parameters:
    `uri` - the image's URI
    `rect` - the rectangle in which the image shall be painted
  Throws:
    `IFException` - if an error occurs while handling this event

### createRenderingContext

    protected RenderingContext createRenderingContext()

  Creates a new RenderingContext instance.

  Specified by:
    `createRenderingContext` in class `AbstractIFPainter`
  Returns:
    the new rendering context.

### drawImage

    public void drawImage(org.w3c.dom.Document doc,
                          java.awt.Rectangle rect)
                   throws IFException

  Draws an image (represented by a DOM document) inside a given rectangle. This is the equivalent to an fo:instream-foreign-object in XSL-FO.

  Specified by:
    `drawImage` in interface `IFPainter`
  Parameters:
    `doc` - the DOM document containing the foreign object
    `rect` - the rectangle in which the image shall be painted
  Throws:
    `IFException` - if an error occurs while handling this event

### clipRect

    public void clipRect(java.awt.Rectangle rect)
                  throws IFException

  Restricts the current clipping region with the given rectangle.

  Specified by:
    `clipRect` in interface `IFPainter`
  Parameters:
    `rect` - the rectangle's coordinates and extent
  Throws:
    `IFException` - if an error occurs while handling this event

### fillRect

    public void fillRect(java.awt.Rectangle rect,
                         java.awt.Paint fill)
                  throws IFException

  Fills a rectangular area.

  Specified by:
    `fillRect` in interface `IFPainter`
  Parameters:
    `rect` - the rectangle's coordinates and extent
    `fill` - the fill paint
  Throws:
    `IFException` - if an error occurs while handling this event

### drawBorderRect

    public void drawBorderRect(java.awt.Rectangle rect,
                               BorderProps before,
                               BorderProps after,
                               BorderProps start,
                               BorderProps end)
                        throws IFException

  Draws a border rectangle. The border segments are specified through `BorderProps` instances.

  Specified by:
    `drawBorderRect` in interface `IFPainter`
  Overrides:
    `drawBorderRect` in class `AbstractIFPainter`
  Throws:
    `IFException`

### drawLine

    public void drawLine(java.awt.Point start,
                         java.awt.Point end,
                         int width,
                         java.awt.Color color,
                         RuleStyle style)
                  throws IFException

  Draws a line. NOTE: Currently, only horizontal lines are implemented!

  Specified by:
    `drawLine` in interface `IFPainter`
  Overrides:
    `drawLine` in class `AbstractIFPainter`
  Throws:
    `IFException`

### drawText

    public void drawText(int x,
                         int y,
                         int letterSpacing,
                         int wordSpacing,
                         int[] dx,
                         java.lang.String text)
                  throws IFException

  Draws text. The initial coordinates (x and y) point to the starting point at the normal baseline of the font. The parameters letterSpacing, wordSpacing and the array dx are optional and can be used to influence character positioning (for example, for kerning).

  Specified by:
    `drawText` in interface `IFPainter`
  Parameters:
    `x` - X-coordinate of the starting point of the text
    `y` - Y-coordinate of the starting point of the text
    `letterSpacing` - additional spacing between characters (may be 0)
    `wordSpacing` - additional spacing between words (may be 0)
    `dx` - an array of adjustment values for each character in X-direction (may be null)
    `text` - the text
  Throws:
    `IFException` - if an error occurs while handling this event

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| fop 1.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 1999-2010 The Apache Software Foundation. All Rights Reserved.